/*
 * @author Choi Dae-Sung @ D&SOFT
 * @version 2.0, 08/06/17
 *
 * function	: description
 */

import java.lang.*;
import java.util.*;

class TBSP
{
	public static HashMap parse(String tbspstr)
	{
		HashMap map;

		map = new HashMap();

		String[] strarr = tbspstr.split("\n");

		for (int i = 0; i < strarr.length; i++)
		{
			String line = strarr[i];
			String keyval[] = line.split(":");
			if (keyval.length < 1)
				continue;
			String key = keyval[0];
			String value = keyval[1];

			if (key == "MESSAGE")
			{
				if (map.containsKey(key))
				{
					String tmpval = (String)map.get(key);
					map.put(key, tmpval + "\n" + value);
				} else {
					map.put(key, value);
				}
			} else {
				map.put(key, value);
			}
		}

		return map;
	}

	public static String build(HashMap map)
	{
		String tbspstr="";

		Set set = map.keySet();
		Object[] keys = set.toArray();
		for (int i = 0; i < keys.length; i++)
		{
			String key = (String)keys[i];
			String value = (String)map.get(key);
			if (key == "MESSAGE")
			{
				String[] strarr = value.split("\n");
				for (int j = 0; j < strarr.length; j++)
				{
					tbspstr = tbspstr + key + ":" + strarr[j] + "\n";
				}
			} else {
				tbspstr = tbspstr + key + ":" + value + "\n";
			}
		}
		return tbspstr;
	}
}
